/*  SpreaCrumbs, version 0.2
 *  2010
 *  
 *  Author: Ricardo Kawase
 *  Review: Ricardo Kawase
 *  Last Modified: 2008-09-29
 *
 *--------------------------------------------------------------------------*/
var spreadcrumb_facebook_userName = "";
var checkVersion = false;
var spreadcrumb_version = "0.2.2010xxxx";
var SERVER = "http://spreadcrumbsdev.l3s.uni-hannover.de"

// -----------------------------------------------------------------
// Try to get state of SpreadCrumbs add on
// if it returns a error means that it hasn't been set yet.
// In this case set to true.
// -----------------------------------------------------------------   

// Service for saving preferences on the browser
var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
try{
    SpreadCrumbsOnOff = prefManager.getBoolPref("extensions.SpreadCrumbs.enabled");

}
catch(error)
{
    try{
        checkSpreadCrumbStatus();
    }
    catch(error)
    {
        if(DEBUG_ERRORS)
        {
            alert("SpreadCrumbs: Error saving preferences. "+error);
        }
        else
        {
            diseabledByError();
        }
    }
}

var javascriptLibrary = "YAHOO"; //="SCRIPTACULOUS"
var tabControl = new Array();
var spreadCrumbs = new Array(); //true;
var gDoc = new Array();
var gDocTitle = new Array();
var gUrl = new Array();
var mayHaveNewCrumb = new Array();
var mayHaveNewTopic = new Array();
var checkReplyforCrumbID = new Array();
var checkReplyforTopicID = new Array();
var checkReplyID = new Array();
var popAddWindow = new Array();
var popReplyWindow= new Array();
var needReload = new Array();
var frameSetDoc = new Array(); 

var scriptAdded = new Array(); 

var returnVal = null;

var posX = 0;
var posY = 0;
var currentClickedDoc = null;
var currentFrameUrl = "";
var currentClickedTab = null;



/*--------------------------------------------- CODE INSERTING PART ------------------------------------------- */
/*------------------------------------------------------------------------------------------------------------- */

var SpreadCrumbs = {

// -----------------------------------------------------------------
// on page load 
// -----------------------------------------------------------------   
  onLoad: function() {
    
    try
    {
        checkSpreadCrumbStatus();
    }
    catch(error)
    {
        if(DEBUG_ERRORS)
        {
            alert("SpreadCrumbs: error loading. "+error);
        }
        else
        {
            diseabledByError();
        }
    }

    // initialization code
    this.initialized = true;

        // this runs on every page loaded in the window
        // including frames and iframes
        // 
        // when a page has iframes the scripts run only on the top page (1)
        // when the page has frames (frameset) thes cripts go only (2) on the frame pages 
        // but keeping the top URL as reference. (3)
       var line = 0;
        function onPageLoad(event){
            try{

              //first check if it is HTML
              if (event.originalTarget instanceof HTMLDocument) {
                var doc = event.originalTarget;
                targetURL = event.originalTarget.URL;

                // (2) return and stop if it has frameset.
                thisDocHasFrameSet = doc.getElementsByTagName("frameset").length;
                if(thisDocHasFrameSet)
                {
                    return;
                }

                var stepDoc = doc;
                                  
                if (event.originalTarget.defaultView.frameElement) {
                  while (stepDoc.defaultView.frameElement) {
                    
                    // if parent document of this step has frameset
                    // we want the current one as the target doc doc (3).
                    if(stepDoc.defaultView.frameElement.ownerDocument.getElementsByTagName("frameset").length>0)
                    {   
                       thisDocHasFrameSet = true;
                       doc = stepDoc;
                    }
                    // in the case that there's no frameset and just iframes we take the top document
                    stepDoc=stepDoc.defaultView.frameElement.ownerDocument;
                  }
                  //do something to treat frameset.
                }


                               
                // in any case the topDoc is the real document in the window. contains the URL to be saved.
                var topDoc = stepDoc;

                // if doesnt have frame set the target document "doc "is the top document
                if(!thisDocHasFrameSet)
                    doc = topDoc;


                var numTabs = getBrowser().tabContainer.childNodes.length;
                var tabIndex = -1;
                targetURL = doc.URL;

                // finds the tab where is the top document
                for(var i=0; i<numTabs; i++) 
                {
                    var currentBrowser = getBrowser().getBrowserAtIndex(i);
     
                    // compare to find the index of the loaded page
                    if(gBrowser.getBrowserAtIndex(i).contentDocument == topDoc)
                    {
                        tab = getBrowser().tabContainer.childNodes[i];
                        tabIndex = i;
                        break;
                    }
                 }
              }
             }
             catch(error){
                if(DEBUG_ERRORS)
                {
                    alert(line);
                    alert("SpreadCrumbs: error getting doc. "+error);
                }
                else
                {
                    diseabledByError();
                }
             } 


            str_pages = "onbrowser: " +topDoc.URL+ "\n";
            str_pages += "target url: " +doc.URL+ "\n";
            //alert(str_pages);

             if(tabIndex<0)
                return;

			 if(tabControl.indexOf(tab)<0)
			 	tabControl.push(tab);
			 
			 tabIndex = tabControl.indexOf(tab);
			 
			 spreadCrumbs[tabIndex] = true;
			 gDoc[tabIndex] = null;
			 gDocTitle[tabIndex] = null;
			 gUrl[tabIndex] = null;
			 mayHaveNewCrumb[tabIndex] = false;
			 mayHaveNewTopic[tabIndex] = false;
			 checkReplyforCrumbID[tabIndex] = null;
			 checkReplyforTopicID[tabIndex] = null;
			 checkReplyID[tabIndex] = null;
			 popAddWindow[tabIndex] = null;
			 popReplyWindow[tabIndex] = null;
			 needReload[tabIndex] = false;
			
			 if(thisDocHasFrameSet)
                frameSetDoc[tabIndex] = topDoc;
             else
                frameSetDoc[tabIndex] = null;

            gUrl[tabIndex]=topDoc.URL;

           //var doc = event.originalTarget;
           //alert(doc);

           // if is image disable all functions
		     if( !(doc instanceof HTMLDocument) || (doc instanceof ImageDocument))
		     {
			     spreadCrumbs[tabIndex] = false;
			     return;
		     }
		     // if is pdf ge disable all functions
		     if( gUrl[tabIndex].substr(gUrl[tabIndex].length-4, gUrl[tabIndex].length) == ".pdf" )
		     {
			     spreadCrumbs[tabIndex] = false;
			     return;
		     }			 

           if(1)
           {
               var stringLocation = doc.location+"";
               
               //Knows sites that the scripts doesnt work 
               if(stringLocation.indexOf("xxxxx")>0)
               {
                    spreadCrumbsEnable[tabIndex] = false;
                    return;
               }
                          	
               try
               	{

               	}
               	catch(error)
               	{
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Cookies Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }               	
               	};

               
               // save the current URL on the browser.
               if(gUrl[tabIndex]==doc.location.href)
               {
                    gDoc[tabIndex] = doc;
                    gDocTitle[tabIndex] = doc.title;
                    //return;
               }                


			   // if it's off or there's no cookie info set it to off
			   if(!SpreadCrumbsOnOff || !g_sc_userUID)
			   {
                    doc.addEventListener("click", function(e) { currentClickedDoc = e.originalTarget.ownerDocument; }, true);               
                    return; 
               }        
               
               // Set the database with the information about user login and version in use.
               if(checkVersion)
               {
                    updateVersionInfo();
               }
               

                
               if(scriptAdded.indexOf(doc)>0)
                return;
               
               
               scriptAdded[scriptAdded.length]= doc;
               
               addScripts(doc);
               extensionLoadCrumbs(doc);
            }
        }
    
        // -----------------------------------------------------------------
        // Load crumbs of the page 
        // It uses the current url in the browser and get all the crumbs
        // if there are frames the script.js only insert the results for the current frame
        // -----------------------------------------------------------------   
         function extensionLoadCrumbs(doc)
         {
            cUrl = cleanUrl(doc.location.href);
            var param = "?user="+g_sc_userUID+"&url="+cUrl;
            //alert(SERVER+"/ajax/spreadCrumbs_loadCrumbs_multi.php?user="+g_sc_userUID+"&url="+cUrl);
            
            makeRequest(SERVER+"/ajax/spreadCrumbs_loadCrumbs_multi.php", param, "loadAll", doc);
         }

        // -----------------------------------------------------------------
        // Add the scripts into the document object
        // -----------------------------------------------------------------   
         function addScripts(doc)
         {
         
             //var debug = doc.createElement("a");
             //debug.innerHTML = "inserting scripts...";
             //doc.body.appendChild(debug);         
             
             // If is't already in the page, return
             if(doc.getElementById("SPREADCRUMBS_SCRIPTS"))
                return;

             var cssClean = doc.createElement("link");
             cssClean.rel = "stylesheet";
             cssClean.type = "text/css";
             cssClean.href = SERVER+"/styles/crumbs.css";
             doc.body.appendChild(cssClean);

             var script = doc.createElement("script");
             script.id = "SPREADCRUMBS_SCRIPTS";
             script.type = 'text/javascript';
             script.innerHTML = "g_sc_userUID="+g_sc_userUID+";  ";
             doc.body.appendChild(script);         
         
             if(javascriptLibrary=="YAHOO")
             {
                var script = doc.createElement("script");
                script.type = 'text/javascript';
                script.src = SERVER+"/scripts/yahoo-dom-event.js";
                try{
                  doc.body.appendChild(script);
                }
                catch(error){
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Script Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }               	                
                }
             
                var script = doc.createElement("script");
                script.type = 'text/javascript';
                script.src = SERVER+"/scripts/yahoo-dragdrop-min.js";
                try{
                 doc.body.appendChild(script);
                }
                catch(error){
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Script Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }   
                }
            }
            else if (javascriptLibrary=="SCRIPTACULOUS")
            {
                var script = doc.createElement("script");
                script.type = 'text/javascript';
                script.src = SERVER+"/scripts/prototype.js";
                //script.src = "file:///C:/Program%20Files/Mozilla%20Firefox/extensions/spreadcrumbs/content/scripts/prototype.js";

                try{
                    doc.body.appendChild(script);
                }
                catch(error){
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Script Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }   
                }

                var script = doc.createElement("script");
                script.type = 'text/javascript';
                script.src = SERVER+"/scripts/effects.js";
                //script.src = "file:///C:/Program%20Files/Mozilla%20Firefox/extensions/spreadcrumbs/content/scripts/effects.js";
                try{
                    doc.body.appendChild(script);
                }
                catch(error){
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Script Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }   
                }
                
                var script = doc.createElement("script");
                script.type = 'text/javascript';
                script.src = SERVER+"/scripts/dragdrop.js";
                //script.src = "file:///C:/Program%20Files/Mozilla%20Firefox/extensions/spreadcrumbs/content/scripts/dragdrop.js";
                try{
                    doc.body.appendChild(script);
                }
                catch(error){
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Script Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }                   
                }
            }
          
            //This is SpreadCrumbs scripts
            var script = doc.createElement("script");
            script.type = 'text/javascript';
            script.src = SERVER+"/scripts/scripts.js";
            //script.src = "file:///C:/Program%20Files/Mozilla%20Firefox/extensions/spreadcrumbs/content/scripts.js";
                          
            try{
              //doc.getElementsByTagName('head')[0].appendChild(script); 
              doc.body.appendChild(script);
            }
            catch(error){
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Script Error. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }   
            }

            doc.addEventListener("mouseup", function(e) { updateCrumbPosition(e); }, true);
            doc.addEventListener("click", function(e) { currentClickedDoc = e.originalTarget.ownerDocument; SpreadCrumbs.mouseDown(e); if(e.button!=0){return;} deleteCrumbCheck(e); replyCrumbCheck(e); crumbNavigationCheck(e);}, true);               
         }
 
    // addEventListener before new tab
    gBrowser.addEventListener("pageshow", onPageLoad, false); 

  },





// -----------------------------------------------------------------
// Menu item for Add Crumb
// -----------------------------------------------------------------   
  onMenuItemAddCrumb: function(e, fromClick) {


		  //if(!SpreadCrumbsOnOff)
		  {
		      //alert("SpreadCrumbs: You have to enable SpreadCrumbs before adding crumbs.");
		      //return;
		  }


		var tab = getBrowser().selectedTab;
		var tabIndex = tabControl.indexOf(tab);
        currentClickedTab = tabIndex;

                
		// if is not adding from the right-click menu clean the position values
		if(!fromClick)
		{
		    // if is not from click clean the currentCLicked
		    currentClickedDoc = null;
		    currentFrameUrl = "";
		    
			posX = gDoc[tabIndex].body.scrollLeft;
			if(posX==0)
			    posX = gDoc[tabIndex].documentElement.scrollLeft;
						
			posY = gDoc[tabIndex].body.scrollTop;
			if(posY==0)
			    posY = gDoc[tabIndex].documentElement.scrollTop;
			
			posX += gDoc[tabIndex].body.clientWidth/2 -50;
			posY += gDoc[tabIndex].body.clientHeight/2 - 80;

		}
		
           
           
        if(!spreadCrumbs[tabIndex])
     	{
     	     getBrowser().mCurrentBrowser.reload();
     		//alert("SpreadCrumbs: Not avaiable here... sorry! \n" + gUrl[tabIndex]);
     		return;
     	}
     	
          // If there's already an AddCrumb window opened
          if(popAddWindow[tabIndex]!=null)
          {
            if(!popAddWindow[tabIndex].closed)
            {
                popAddWindow[tabIndex].focus();
                return;
            }
          }     
    
        var popW = 1000;
        var popH = 650;
        var w = screen.availWidth;
        var h = screen.availHeight;
        var left = (w-popW)/2;
        var top = (h-popH)/2;    
    
        // check for the current clicked page if it's a frame.
   		cUrl = cleanUrl(gUrl[tabIndex]);
   		
   		
        if(frameSetDoc[tabIndex])
        {
            currentFrameUrl = cleanUrl(currentClickedDoc.URL);
        }
        else
            currentFrameUrl = "";
            
   		
   		// if there is no clicked use current doc as the one in visualization.
   		if(!currentClickedDoc)
            currentClickedDoc = gDoc[tabIndex];
                      
        if(cUrl == currentFrameUrl)
            currentFrameUrl="";


        if(!g_sc_userUID)
        {
            alert("You have to be logged on SpreadCrumbs!");
            toggleSidebar("sc_sidebar", true);
            return;
        }

            
        //the returnValue is the new topicUID in the finishOnMenuItemAddCrumb function
        popAddWindow[tabIndex] = window.openDialog(SERVER+"/spreadCrumbs_addCrumbs_dlgff3.php?posX="+posX+"&posY="+posY+"&url="+cUrl+"&frameUrl="+currentFrameUrl, "Add Crumb", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
        var w = popAddWindow[tabIndex];
        //w.addEventListener("close",  function (e) {  alert('out'+ w.topicUID); } ,false);

        w.onunload = function (){
            // this var is in the dialog window document
            // w.location.href = "about:blank"
            if(w.newTopicUID!=null)
                SpreadCrumbs.finishOnMenuItemAddCrumb(w.newTopicUID);
        };

        popAddWindow[tabIndex].focus();
  },
  
  finishOnMenuItemAddCrumb: function(newTopicUID){
  
        var needReload = false;
        // If the user was not logged before we need to reload the page to get all crumbs.
        if(g_sc_userUID==null || g_sc_userUID=="" || SpreadCrumbsOnOff==false)
            needReload = true;
              
        if(needReload)
        {
            getBrowser().mCurrentBrowser.reload();        
        }
        else
        {
            if(newTopicUID!=null)
            {
                extensionLoadNewTopics(currentClickedDoc, newTopicUID);
                currentClickedDoc = null;
                refreshSideBar();
            }
        }

        SpreadCrumbsOnOff=true;
        checkSpreadCrumbStatus();
  },
 
  // Mousedow to keep track of the right click to get position and the frame to add.
  mouseDown: function(e) {


    function getY( oElement )
    {
        var iReturnValue = 0;
        while( oElement != null ) {
            iReturnValue += oElement.offsetTop;
            oElement = oElement.offsetParent;
        }
        return iReturnValue;
    };
    function getX( oElement )
    {
        var iReturnValue = 0;
        while( oElement != null ) {
            iReturnValue += oElement.offsetLeft;
            oElement = oElement.offsetParent;
        }
        return iReturnValue;
    };    

  	if(e.button!=2)
  		return;
  	else
  	{
    
        try{
            
             clickedDoc = e.originalTarget.ownerDocument;

             //click on an iframe get the position of the iframe
             if(clickedDoc.defaultView.frameElement && (!clickedDoc.defaultView.frameElement.ownerDocument.getElementsByTagName("frameset").length))
             {
                
                x = getX(clickedDoc.defaultView.frameElement);
                y = getY(clickedDoc.defaultView.frameElement);
                
                posX = x;
                posY = y;
                
                //alert("frame: " +posX + "_" +posY);
                return;
             }
        }
        catch(e)
        {
            alert(e);
        }
      	
  		posX = e.pageX;
		posY = e.pageY;
		
		//alert(posX + "_" +posY);
  	}
  },
    
};

addRemoveSpreadCrumbListener();

function addRemoveSpreadCrumbListener()
{
    try
    {
        window.addEventListener("load", function(e) { SpreadCrumbs.onLoad(e); }, false); 
        window.addEventListener("mousedown", function(e) { SpreadCrumbs.mouseDown(e); }, false); 
    }
    catch(error)
    {
        if(DEBUG_ERRORS)
        {
            alert("SpreadCrumbs: Error adding listeners "+ error);
        }
        else
        {
            diseabledByError();
        }                   
    }
}


// -----------------------------------------------------------------
// Try check the status of the extension if it's enabled and if there's a userUID
// and set the Add-on Menu text and state.
// -----------------------------------------------------------------   
function checkSpreadCrumbStatus()
{
    try
    {
        // if there's no id and it's Off
        if(!SpreadCrumbsOnOff || !g_sc_userUID)
        {
            SpreadCrumbsOnOff = false;
            //document.getElementById("spreadcrumbsMenuState").setAttribute("checked", false);
            //document.getElementById("spreadcrumbsContextMenuAdd").setAttribute("label", "Add Crumb");
            //document.getElementById("spreadcrumbsMenuState").setAttribute("label", "Enable");
            prefManager.setBoolPref("extensions.SpreadCrumbs.enabled", false); 
            return false;
        }
    }
    catch(error)
    {
        // dont't display error cause there's something wrong when is the first instalation
        // alert("SpreadCrumbs: Error Add-on. "+error);
    }
}

// -----------------------------------------------------------------
// Diseable by Error
// -----------------------------------------------------------------   
function diseabledByError(error)
{
    // This avoid multiple messages
    if(SpreadCrumbsOnOff)
    {
        msg = "SpreadCrumbs could not connect!\n";
        msg += "The problem is either the connection with Facebook or SpreadCrumbs.\n";
        msg += "If you are not a user of the facebook application go to:\n";
        msg += "http://apps.new.facebook.com/spreadcrumbs/\n";
        msg += "Meanwhile, to avoid problems during the navigation SpreadCrumbs will disable itself!";
        alert(msg);
    }
    
    SpreadCrumbsOnOff = false;
    document.getElementById("sc_menu_login").setAttribute("checked", false);
    document.getElementById("spreadcrumbsContextMenuAdd").setAttribute("label", "Add Crumb");
    document.getElementById("sc_menu_login").setAttribute("label", "Enable");
    prefManager.setBoolPref("extensions.SpreadCrumbs.enabled", false); 
    
    return false;
}

// -----------------------------------------------------------------
// Diseable by connection problem, just reset the labels but still try to 
// connect next time
// -----------------------------------------------------------------   
function diseabledByConnectionError(error)
{
    document.getElementById("spreadcrumbsContextMenuAdd").setAttribute("label", "Add Crumb (couldn't find user)");    
    document.getElementById("sc_menu_login").setAttribute("label", "Enabled (couldn't find user)");    
    
    return false;
}


function updateVersionInfo()
{
    try
    {
        var param = "?userUID="+g_sc_userUID+"&version="+spreadcrumb_version;
        makeRequest(SERVER+"/ajax/spreadCrumbs_updateVersionInfo.php", param, "updateVersion", null);
    }
    catch(error)
    {
        diseabledByError(error);
    }
    
    // set check version to false, to check only once per session.
    checkVersion = false;
}


// -----------------------------------------------------------------
// Get the name of the looged user 
// -----------------------------------------------------------------   
function setUserName(name, clean)
{
    if(clean)
    {
        spreadcrumb_facebook_userName = "";
        document.getElementById("spreadcrumbsContextMenuAdd").setAttribute("label", "Add Crumb");
        document.getElementById("sc_menu_login").setAttribute("label", "Enabled");    
        return;
    }
    
    if(!name || name==null || name=='')
    {
        diseabledByError();
        return;
    }   
    
    spreadcrumb_facebook_userName = name;
    document.getElementById("spreadcrumbsContextMenuAdd").setAttribute("label", "Add Crumb ("+spreadcrumb_facebook_userName+")");
    document.getElementById("sc_menu_login").setAttribute("label", "Enabled ("+spreadcrumb_facebook_userName+")");
    
    // This things are set once the userName is retrieved
    SpreadCrumbsOnOff = true;     
    document.getElementById("sc_menu_login").setAttribute("checked", true);
    prefManager.setBoolPref("extensions.SpreadCrumbs.enabled", true); 
}
    

/*------------------------------------------------ AJAX PART ------------------------------------------------ */
/*------------------------------------------------------------------------------------------------------------- */


    //var http_request = false;
    
    // -----------------------------------------------------------------
    // AJAX request
    // -----------------------------------------------------------------    
    function makeRequest(url, parameters, action, caller) {
      var http_request = false;
      
      if (window.XMLHttpRequest) { // Mozilla, Safari,...
         http_request = new XMLHttpRequest();
         if (http_request.overrideMimeType) {
     	    // set type accordingly to anticipated content type
            //http_request.overrideMimeType('text/xml');
            http_request.overrideMimeType('text/html');
         }
      } else if (window.ActiveXObject) { // IE
         try {
            http_request = new ActiveXObject("Msxml2.XMLHTTP");
         } catch (error) {
            try {
               http_request = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (error) {}
         }
      }
      if (!http_request) {

            if(DEBUG_ERRORS)
            {
                alert('SpreadCrumbs: Cannot create XMLHTTP instance');
            }
            else
            {
                diseabledByError();
            }      
            
            return false;
      }
      
      // get response from AJAX and use it depending on the action.
      http_request.onreadystatechange = function getResponse(){ useResponse(http_request, action, caller) };
      
      
      //alert(url + parameters);
      
      
      try{
            http_request.open('GET', url + parameters, true);
            http_request.send(null);
        }
        catch(error)
        {
            if(DEBUG_ERRORS)
            {
                alert("SpreadCrumbs: Server request error. \n" + error);
            }
            else
            {
                diseabledByError();
            }                  
        }
    }
    
    // -----------------------------------------------------------------
    // Get AJAX response
    // -----------------------------------------------------------------
    function useResponse(http_request, action, caller) {
      if (http_request.readyState == 4) {
         if (http_request.status == 200) {

            result = http_request.responseText;

            if(g_sc_userUID==null || g_sc_userUID=="")                
                return;

            if(action=="loadAll")
            {
                writeCrumbs(result, caller);
                checkForNewCrumbs();
            }
                
            if(action=="loadNewCrumb")
            {
                writeNewCrumbs(result, caller);                
            }

            if(action=="loadNewTopic")
            {
                writeNewTopic(result, caller);                                
            }
           
            if(action=="deleteSingleCrumb")
            {
                //alert(result); 
            }

            if(action=="getUserName")
            {
                setUserName(result);                
            }
            
            if(action=="updateVersion")
            {
                //alert(result);                
            }                
                
            if(action=="navigateToCrumb")
            {
                // navigate to next crumb
                if(result.length>4)
                    getBrowser().contentWindow.location.href=result;                
                // or change toolTip
                else
                    caller.title = "no more crumbs...";
            }
                      
            if(action=="updatePosition")
            {
                if(DEBUG_AJAX)
                    alert("RESPONSE: "+http_request.responseText);
            }
                                        
            return result;
            
         } else {
            if(DEBUG_ERRORS)
            {
                alert('SpreadCrumbs: Connection problem.');
            }
            else
            {
                //diseabledByError();
                diseabledByConnectionError();
            }
            
         }
      }
    }
    
    // -----------------------------------------------------------------
    // Write crumbs variables on window doc and trigger loadCrumbs() from 
    // the inserted script.js (from loadAll)
    // -----------------------------------------------------------------
    function writeCrumbs(result, doc) {
        
        if(result.length>10)
        {
            var script = doc.createElement("script");
            script.type = 'text/javascript';

            script.innerHTML = " try{";
            script.innerHTML += result+";scFunction_loadCrumbs();sc_userId="+g_sc_userUID+";";
            script.innerHTML += "} " ; 
            script.innerHTML += " catch(e){ ";
            // Don't alert. this exception occurs when the AJAX call is made and the page changes
            // before the response.            
            script.innerHTML += " /*alert(e);*/ "; 
            script.innerHTML += "} ";

            doc.body.appendChild(script); 
        }
    }


    // -----------------------------------------------------------------
    // Load new topics on add (from loadNewTopics)
    // -----------------------------------------------------------------

    function extensionLoadNewTopics(doc, topicUID)
    {
        // Before adding new topics check the cookies.

        cUrl = cleanUrl(doc.location.href);
        var param = "?user="+g_sc_userUID+"&topicUID="+topicUID+"&url="+cUrl;
        makeRequest(SERVER+"/ajax/spreadCrumbs_loadNewTopic_multi.php", param, "loadNewTopic", doc);
    }

    // -----------------------------------------------------------------
    // Write NEW topics  variables on window doc and trigger loadNewTopics() from 
    // the inserted script.js (from loadNewTopics)
    // -----------------------------------------------------------------
    
    function writeNewTopic(result, caller) {

        doc = caller;
        if(result!=null && result!="" && result.length>10)
        {
            var script = doc.createElement("script");
            script.type = 'text/javascript';
            script.innerHTML = result+";scFunction_loadNewTopic()";
            doc.body.appendChild(script);        
        }
    }


    // -----------------------------------------------------------------
    // Load new crumbs on reply (from loadNewCrumbs)
    // -----------------------------------------------------------------
      function extensionLoadNewCrumbs(doc)
     {
        var tab = getBrowser().selectedTab;
        var tabIndex = tabControl.indexOf(tab);
			       	
        var param = "?user="+g_sc_userUID;
        param += "&parentCrumbID="+checkReplyforCrumbID[tabIndex];
        param += "&topicID="+checkReplyforTopicID[tabIndex];
        param += "&containerID="+checkReplyID[tabIndex];
        makeRequest(SERVER+"/ajax/spreadCrumbs_loadNewCrumb_multi.php", param, "loadNewCrumb", doc);
     }

    // -----------------------------------------------------------------
    // Write NEW crumbs variables on window doc and trigger loadNewCrumbs() from 
    // the inserted script.js (from loadNewCrumbs)
    // -----------------------------------------------------------------
    function writeNewCrumbs(result, doc) {

        var script = doc.createElement("script");
        script.type = 'text/javascript';
        script.innerHTML = result+";scFunction_loadNewCrumbs()";
        doc.body.appendChild(script); 
    }


    // -----------------------------------------------------------------
    // Updated crumb positon 
    // 
    // IMPORTANT:   The TOPICS and CRUMBS structure and IDs are strictly connected with the
    //              scripts (scripts.js). Any change here must be checked
    //              with all features of the extension.
    // -----------------------------------------------------------------     
    function updateCrumbPosition(e)
    {
        var crumb = e.originalTarget;
      
        if(crumb == null)
            return;

        var depth = 50;
        var i = 0;
        
        while(crumb.id && crumb.id.indexOf("SPREADCRUMB_TOPIC_")!=0)
        {
            if(i==depth)
                return;
            try
            {
                crumb = crumb.parentNode;
            }
            catch(error)
            {
                return;
            }
            i++;
        }
 
        if(crumb.id.indexOf("SPREADCRUMB_TOPIC_")==0)
        {
            param = "?posX=" +crumb.style.left.substring(0,crumb.style.left.indexOf("px")); 
            param += "&posY=" +crumb.style.top.substring(0,crumb.style.top.indexOf("px")); 
            param += "&topicID=" +crumb.id.substring(18,crumb.id.lastIndexOf("_"));
            
            makeRequest(SERVER+"/ajax/spreadCrumbs_updateCrumbPosition.php", param, "updatePosition");
        }
        //do ajax to update position.
    }
    
    // -----------------------------------------------------------------
    // Delete crumb
    // 
    // IMPORTANT:   The TOPICS and CRUMBS structure and IDs are strictly connected with the
    //              scripts (scripts.js). Any change here must be checked
    //              with all features of the extension.
    // -----------------------------------------------------------------   
    function deleteCrumbCheck(e)
    {
        try
        {
            if( (e.originalTarget.id!="SPREADCRUMBS_DELETE_TOPIC") && e.originalTarget.id!="SPREADCRUMBS_DELETE_CRUMB")
            return;

            crumb = e.originalTarget;

            if(crumb == null)
                return;


            // don't waste time on obj non spreadcrumbs objects
            // but try 1 first parentNode.
            if(crumb.id.indexOf("SPREADCRUMB")<0)
            {
                crumb = crumb.parentNode;
                if(crumb == null)
                    return;
                
                if(crumb.id.indexOf("SPREADCRUMB")<0)
                    return;
            }
       }
       catch(e)
       {
        alert(e);
       }

        var message = "Are you sure you want to delete this entire topic?";
        var deleteSingleCrumb = false;
        
        
        var topic = crumb;
        while(topic.id.indexOf("SPREADCRUMB_TOPIC_")!=0)
        {
            topic = topic.parentNode;
        }
   
        try
        {
           subDivs = topic.getElementsByTagName("div");
           var crumbsCount = 0;
           for(var i=0; i<subDivs.length;i++)
           {
                if(subDivs[i].id.indexOf("SPREADCRUMB_CONTENT_CRUMB_")==0)
                    crumbsCount++;
           }

            if( (e.originalTarget.id=="SPREADCRUMBS_DELETE_CRUMB") && (crumbsCount>1) )
            {
                while(crumb.id.indexOf("SPREADCRUMB_CONTENT_CRUMB_")!=0)
                {

                    crumb = crumb.parentNode;
                }
                
                deleteSingleCrumb = true;
                    message = "Are you sure you want to delete this crumb?";
            } 
            else if ( (e.originalTarget.id=="SPREADCRUMBS_DELETE_CRUMB") && (crumbsCount<=1) )
            {

                message = "Deleting the last crumb will delete the topic. Are you sure you want to delete this crumb?";
                crumb = topic;
            }
            else
            {
                crumb = topic;        
            }
        }
        catch(error)
        {
            if(DEBUG_ERRORS)
            {
                alert("Spreadcrumbs: Error deleting crumb. " + error);
            }
            else
            {
                diseabledByError();
            }                              
            
            return;
        };
                

                
        // If deleting crumb use javascript confirm(), delete it by AJAX and remove it from screen.
        if(e.originalTarget.id=="SPREADCRUMBS_DELETE_CRUMB")
        {
            //if(confirm(message, "Delete Crumb"))

            var answer = scAskYesNoQuestion("Delete Crumb", message, "Delete", "Cancel")
 
            if(answer)
            {
                param = "?crumbID=" +crumb.id.substring(crumb.id.lastIndexOf("_")+1,crumb.id.length); 
                
                var topicUID = crumb.id.substring(0,crumb.id.lastIndexOf("_"));
                topicUID = topicUID.substring(topicUID.lastIndexOf("_")+1, topicUID.length);
                param += "&topicID=" + topicUID; 
                param += "&userID=" +g_sc_userUID; 
                param += "&deleteSingleCrumb=" +deleteSingleCrumb; 
                makeRequest(SERVER+"/ajax/spreadCrumbs_deleteCrumb_multi.php", param, "deleteSingleCrumb");
                
                try{
                    if( (e.originalTarget.id=="SPREADCRUMBS_DELETE_CRUMB")  && (crumbsCount>1)  )
                        crumb.parentNode.appendChild(crumb.lastChild);
                        
                    crumb.parentNode.removeChild(crumb);
                    refreshSideBar();
                }
                catch(error)
                {
                    if(DEBUG_ERRORS)
                    {
                        alert("SpreadCrumbs: Error removing topic. \n" + error);
                    }
                    else
                    {
                        diseabledByError();
                    }   
                }
                return;
            }        
        }

        // If deleting topic, opens the dialog for DISCONNECT OR STANDBY options.
        if( (e.originalTarget.id=="SPREADCRUMBS_DELETE_TOPIC"))
        {
            var popW = 1000;
            var popH = 650;
            var w = screen.availWidth;
            var h = screen.availHeight;
            var left = (w-popW)/2;
            var top = (h-popH)/2; 
            
            var topicUID = crumb.id.substring(0,crumb.id.lastIndexOf("_"));
            topicUID = topicUID.substring(topicUID.lastIndexOf("_")+1, topicUID.length);
            
            var param = "?topicUID=" + topicUID; 
            param += "&userID=" +g_sc_userUID; 

            try{
                //returnVal = window.showModalDialog(SERVER+"/spreadCrumbs_deleteTopic.php"+param, "", "resizable: yes; dialogwidth: "+popW+",; dialogheight:"+popH+"; dialogtop:"+top+"; dialogleft:"+left+""); 
            
                if(!g_sc_userUID)
                {
                    alert("You have to be logged on SpreadCrumbs!");
                    toggleSidebar("sc_sidebar", true);
                    return;
                }            
                //w = window.openDialog(SERVER+"/spreadCrumbs_deleteTopic_dlgff3.php"+param, "", "resizable: yes; dialogwidth: "+popW+",; dialogheight:"+popH+"; dialogtop:"+top+"; dialogleft:"+left+""); 
                w = window.openDialog(SERVER+"/spreadCrumbs_deleteTopic_dlgff3.php"+param, "Change Toopic Status", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
                w.onunload = function (){
                    if(w.returnValue!=null && w.returnValue!='')
                    {
                        returnVal = w.returnValue;
                        if(returnVal=="disconnect" || returnVal=="standBy")
                        {
                            try{
                                topic.parentNode.removeChild(topic);
                                refreshSideBar();
                            }
                            catch(error)
                            {
                                if(DEBUG_ERRORS)
                                {
                                    alert("SpreadCrumbs: Error removing topic. \n" + error);
                                }
                                else
                                {
                                    diseabledByError();
                                }   
                            }
                            return;
                        }
                    }
                };            
                
            }
            catch(e)
            {
                alert(e);
            }
            
        }    
    }
    
    function finishChangeTopicStatus(returnVal)
    {
        alert(returnVal);
    

    }    
    
    // -----------------------------------------------------------------
    // Crumb Navigation
    // 
    // IMPORTANT:   The TOPICS and CRUMBS structure and IDs are strictly connected with the
    //              scripts (scripts.js). Any change here must be checked
    //              with all features of the extension.
    // -----------------------------------------------------------------   
    function crumbNavigationCheck(e)
    {
       try
       {

            if(e.originalTarget.id.indexOf("SPREADCRUMBS_NEXT_CRUMB_NAVIGATION")!=0 && e.originalTarget.id.indexOf("SPREADCRUMBS_PREV_CRUMB_NAVIGATION")!=0 && e.originalTarget.id.indexOf("SPREADCRUMBS_PREV_TOPIC_NAVIGATION")!=0 && e.originalTarget.id.indexOf("SPREADCRUMBS_NEXT_TOPIC_NAVIGATION")!=0)
                return;
        
            crumb = e.originalTarget;
        
            if(crumb == null)
                return;
                
            // don't waste time on obj non spreadcrumbs objects
            // but try 1 first parentNode.
            if(crumb.id.indexOf("SPREADCRUMB")<0)
            {
                crumb = crumb.parentNode;
                if(crumb == null)
                    return;
                
                if(crumb.id.indexOf("SPREADCRUMB")<0)
                    return;
            }
            
            //Both ids follow the same structure: NAME_TOPICUID_CRUMBUID
            //while( (crumb.id.indexOf("SPREADCRUMB_TOPICCONTENT_SPREADCRUMB_TOPIC_")!=0) && (crumb.id.indexOf("SPREADCRUMB_TOPIC_")!=0) && (crumb.id.indexOf("SPREADCRUMB_REPLY_")!=0) )
            //{   
                //crumb = crumb.parentNode;
            //}
            
            
            //ALL ids follow the same structure: NAME_TOPICUID_CRUMBUID
            // The parent of the SPREADCRUMBS_NEXT_CRUMB_NAVIGATION
            // is SPREADCRUMB_CONTENT_CRUMB_ if it is in the crumb reply
            // is SPREADCRUMB_TOPIC_ if it is in the topic header
            while( 
                    (crumb.id.indexOf("SPREADCRUMB_TOPIC_")!=0) && 
                    (crumb.id.indexOf("SPREADCRUMB_CONTENT_CRUMB_")!=0)
                 )
            {   
                crumb = crumb.parentNode;
            }
            
            if( e.originalTarget.id.indexOf("SPREADCRUMBS_NEXT_CRUMB_NAVIGATION")==0 || e.originalTarget.id.indexOf("SPREADCRUMBS_PREV_CRUMB_NAVIGATION")==0)
            {
            
                var next=true;
                if(e.originalTarget.id.indexOf("SPREADCRUMBS_PREV_CRUMB_NAVIGATION")==0)
                    next=false;
            
                param = "?crumbID=" + crumb.id.substring(crumb.id.lastIndexOf("_")+1,crumb.id.length); 
               
                var str_topicID = crumb.id.substring(0,crumb.id.lastIndexOf("_"));
                str_topicID = str_topicID.substring(str_topicID.lastIndexOf("_")+1, str_topicID.length);

                param += "&type=crumb"; 
                param += "&next=" + next; 
                param += "&topicID=" + str_topicID; 
                param += "&userID=" +g_sc_userUID; 
                param += "&fromUserID=" + e.originalTarget.id.substring(e.originalTarget.id.lastIndexOf("_")+1, e.originalTarget.id.length); 
                param += "&toUserID=" + g_sc_userUID;

                makeRequest(SERVER+"/ajax/spreadCrumbs_navigateToCrumb.php", param, "navigateToCrumb", e.originalTarget);
            }
            
            if( e.originalTarget.id.indexOf("SPREADCRUMBS_NEXT_TOPIC_NAVIGATION")==0 || e.originalTarget.id.indexOf("SPREADCRUMBS_PREV_TOPIC_NAVIGATION")==0)
            {
            
                var next=true;
                if(e.originalTarget.id.indexOf("SPREADCRUMBS_PREV_TOPIC_NAVIGATION")==0)
                    next=false;
            
                param = "?crumbID=" + crumb.id.substring(crumb.id.lastIndexOf("_")+1,crumb.id.length); 
               
                var str_topicID = crumb.id.substring(0,crumb.id.lastIndexOf("_"));
                str_topicID = str_topicID.substring(str_topicID.lastIndexOf("_")+1, str_topicID.length);

                param += "&type=topic"; 
                param += "&next=" + next; 
                param += "&topicID=" + str_topicID; 
                param += "&userID=" +g_sc_userUID; 
                param += "&fromUserID=" + e.originalTarget.id.substring(e.originalTarget.id.lastIndexOf("_")+1, e.originalTarget.id.length); 
                param += "&toUserID=" + g_sc_userUID;
                //alert(SERVER+"/ajax/spreadCrumbs_navigateToCrumb.php" + param);

                makeRequest(SERVER+"/ajax/spreadCrumbs_navigateToCrumb.php", param, "navigateToCrumb", e.originalTarget);
            } 
                            
        }
        catch(error)
        {
            if(DEBUG_ERRORS)
            {
                alert("Spreadcrumbs: Navigation Error. "+ error);
            }
            else
            {
                diseabledByError();
            }   
        }
    }
    
    
    // -----------------------------------------------------------------
    // Reply crumb check to load added crumb
    // 
    // IMPORTANT:   The TOPICS and CRUMBS structure and IDs are strictly connected with the
    //              scripts (scripts.js). Any change here must be checked
    //              with all features of the extension.
    // -----------------------------------------------------------------   
    function replyCrumbCheck(e)
    {
        var tab = getBrowser().selectedTab;
        var tabIndex = tabControl.indexOf(tab);
			      	
       crumb = e.originalTarget;
      
       if(crumb == null)
            return;
            
        // get current for the reply    
    	currentFrameUrl = currentClickedDoc.location.href;
            
        // don't waste time on obj non spreadcrumbs objects
        // but try 1 first parentNode.
        if(crumb.innerHTML.indexOf("reply this")>=0)
        {
            while(crumb.id.indexOf("SPREADCRUMB_REPLY_BUTTON_")!=0)
                crumb = crumb.parentNode;
            
            mayHaveNewCrumb[tabIndex] = true;
            checkReplyforCrumbID[tabIndex] = crumb.id.substring(crumb.id.lastIndexOf("_")+1,crumb.id.length); 
            checkReplyforTopicID[tabIndex] = crumb.id.substring(25,crumb.id.lastIndexOf("_")); 
            checkReplyID[tabIndex] = crumb.id;

            var popW = 1000;
            var popH = 650;
            var w = screen.availWidth;
            var h = screen.availHeight;
            var left = (w-popW)/2;
            var top = (h-popH)/2;    

            if(popAddWindow[tabIndex]!=null)
            if(!popAddWindow[tabIndex].closed)
            {
                popAddWindow[tabIndex].close();
                popAddWindow[tabIndex]=null;
            }

            if(!g_sc_userUID)
            {
                alert("You have to be logged on SpreadCrumbs!");
                toggleSidebar("sc_sidebar", true);
                return;
            }
            //the returnValue is the new crumbUID to finishReplyCrumbCheck function
            popAddWindow[tabIndex] = window.openDialog(SERVER+"/spreadCrumbs_replyCrumbs_dlgff3.php?crumbId="+checkReplyforCrumbID[tabIndex]+"&fromUserID="+g_sc_userUID, "Add Crumb", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
            
            var w = popAddWindow[tabIndex];
            //w.addEventListener("close",  function (e) {  alert('out'+ w.topicUID); } ,false);

            w.onunload = function (){
                // w.location.href = "about:blank"
                // this var is in the dialog window document
                if(w.replyCrumbUID!=null)
                    finishReplyCrumbCheck(w.replyCrumbUID);
            };            
            
            popAddWindow[tabIndex].focus();
        }

    }
    
    function finishReplyCrumbCheck(newCrumbUID)
    {
        if(newCrumbUID)
        {
            extensionLoadNewCrumbs(currentClickedDoc);
            refreshSideBar();
        }
    }







/*------------------------------------------------- OTHERS ---------------------------------------------------- */
/*------------------------------------------------------------------------------------------------------------- */

// -----------------------------------------------------------------
// Replace URL special chars
// -----------------------------------------------------------------   
function cleanUrl(url)
{
    url =	url.replace(/&/g, "SPREADCRUMB_AMPERSAND");
    url = url.replace( /[+]/g, "SPREADCRUMB_PLUS");  

    return(url);
}

// -----------------------------------------------------------------
// Functions to get all the frames in the current page
// -----------------------------------------------------------------   
function getAllDocumentFrames(doc)
{
    allFrames = new Array();
    var i=-1;
    
    while(i<allFrames.length)
    {
        frames = getDocumentFrames(doc);
        if(frames.length)
            allFrames = allFrames.concat(frames);
        
        i++;

        doc = allFrames[i];
    }
    
    return allFrames;
}

// -----------------------------------------------------------------
// Functions to get all the frames in the current page
// -----------------------------------------------------------------   
function getDocumentFrames(doc)
{
    try
    {
        var frames = new Array();
        docFrames = doc.getElementsByTagName("frame");
        totalFrames = docFrames.length;
        for(frameCount=0; frameCount<totalFrames; frameCount++)                
        {
           frames.push(docFrames.item(frameCount).contentDocument);
        }
        return frames;
    }
    catch(error)
    {
        if(DEBUG_ERRORS)
        {
            alert("Spreadcrumbs: Frames error. "+ error);
        }
        else
        {
            diseabledByError();
        }           
    }
}

function trim(s) 
{ 
    var l=0; var r=s.length -1; 
    while(l < s.length && s[l] == ' ') 
    {     l++; } 
    while(r > l && s[r] == ' ') 
    {     r-=1;     } 
    return s.substring(l, r+1); 
} 


// ****************************************************
// ****************************************************
// ****************************************************
// ****************************************************
// ****************************************************
// ****************************************************
// ****************************************************
// new functions for v 2


// -----------------------------------------------------------------
// Function to find and scroll the window to the next crumb.
// looks for the tag spreadcrumb on the page
// used by the sidebar.js
// -----------------------------------------------------------------   
g_lastCrumbFoundIndex = -1;
function findNextCrumbOnPage()
{
    try
    {
        var children = new Array();
        doc = getBrowser().contentWindow.document;
        var crumbs = doc.getElementsByTagName("spreadcrumbs");
        
        if(crumbs.length==0)
            return;
        
        g_lastCrumbFoundIndex++;
        
        if(g_lastCrumbFoundIndex>crumbs.length-1)
            g_lastCrumbFoundIndex = 0;
       
        var y = parseInt(crumbs[g_lastCrumbFoundIndex].parentNode.style.top);
        var x = parseInt(crumbs[g_lastCrumbFoundIndex].parentNode.style.left);
       
        getBrowser().contentWindow.scroll(x, y);

    }
    catch(e)
    {
        //do nothing;
    }
}
    

function scAskYesNoQuestion(title, question, trueButton, falseButton)
{
    try
    {
        var scMessageTitle = title;
        var scMessageQuestion = question;
        var scMessageTrueButton = trueButton;
        var scMessageFalseButton = falseButton;
        window.scMessageTitle = scMessageTitle;
        window.scMessageQuestion = scMessageQuestion;
        window.scMessageTrueButton = scMessageTrueButton;
        window.scMessageFalseButton = scMessageFalseButton;
        window.returnValue = false;

        var wSize=300;
        if(scMessageQuestion.length>50)
            wSize=500;
        window.showModalDialog("chrome://spreadcrumbsDev/content/yesNoQuestionDlg.xul", 0, "dialogwidth: "+wSize+"px; dialogheight: 100px;")

        return window.returnValue;
    }
    catch(e)
    {
        return false;
    }
}

function refreshSideBar()
{
  try
  {
     var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
     .getInterface(Components.interfaces.nsIWebNavigation)
     .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
     .rootTreeItem
     .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
     .getInterface(Components.interfaces.nsIDOMWindow);

     var sidebarWindow = mainWindow.document.getElementById("sidebar").contentWindow;

    if( sidebarWindow.location.href== "chrome://spreadcrumbsdev/content/sc_sidebar.xul")
    {
      sidebarWindow.refreshPages('all'); 
    }
  }
  catch(e)
  {
    alert(e);
  }
}

var DEBUG_AJAX = false;
var DEBUG_ERRORS = false;

