g_currentTab = "Topics";
g_clickedFrame = "";
g_mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIDOMWindow);    
getCookies();



//*****************************
// Refresh sidebar pages
//*****************************
function refreshPages(page)
{

    if(page!='all')
        g_currentTab = page;
    
    try
    {
        if(page=='all' || page=='Topics')
        {
            refreshFrame("sc_sidebar_frame_topics", SERVER+"/sidebar/spreadCrumbs_sidebar_topics.php?sc_userUID="+g_sc_userUID);
        }
      
        if(page=='all' || page=='Pages')
        {
            refreshFrame("sc_sidebar_frame_pages", SERVER+"/sidebar/spreadCrumbs_sidebar_pages.php?sc_userUID="+g_sc_userUID);
        }
      
        if(page=='all' || page=='People')
        {
           refreshFrame("sc_sidebar_frame_people", SERVER+"/sidebar/spreadCrumbs_sidebar_people.php?sc_userUID="+g_sc_userUID);
        }         

        refreshFrame("sc_sidebar_frame_trails", SERVER+"/sidebar/spreadCrumbs_sidebar_trails_view.php");

    }
    catch(e){alert(e);}
    
    g_selectedButton = null;
}


//*****************************
// Event for clickig on the page
//*****************************
var g_selectedButton = null;
function onclickTabContent(event, tab)
{
    try
    {
        g_clickedFrame = tab;
        clickedObj = event.target;
        
        if(!clickedObj)
            return;
            
        if(event.button==0)//left-click
        {
            selectItemOnTab(event, clickedObj, tab);
            
            if(clickedObj.hasClassName('sc_login_button'))
            {
                sc_openLoginDlg();
            }
            
        }
        
        if(event.button==2)
        {
            openContextMenu(event, clickedObj);
        }
    }
    catch(e)
    {
        // Do not show error
        // on begining clickedObj.hasClassName is not defined.    
        // alert("onclickTabContent" + e);
    }
}



function onclickViewContent(event, tab)
{
    try
    {
        g_clickedFrame = tab;
        clickedObj = event.target;
        if(!clickedObj)
            return;
            
        if(event.button==0)//left-click
        {
            // if click on the "sc_link" opens the page
            if(clickedObj.hasClassName("sc_trail_link"))
            {
                g_mainWindow.gBrowser.selectedTab = g_mainWindow.getBrowser().addTab(event.target.id);
            }
        }

        if(event.button==2)//right-click
        {
            openContextMenu(event, clickedObj);
        }        
    }
    catch(e)
    {
        alert(e);
    }
}

// when right click
var gClickedObject = null;
var gClickedObjectContainer = null;
function openContextMenu(event, clickedObj)
{
            gClickedObject = clickedObj;
            if(clickedObj.hasClassName('sc_trail_button'))
            {
                var container = clickedObj;
                var i = 0;
                while(container && (!container.hasClassName('sc_trail_button_container_row')) )
                {
                    container = container.parentNode;
                    gClickedObjectContainer = container;
                    i++;
                    if(i>30) //just to avoind infinite loop
                        break;
                }        


                // check the page clicked and enable/disable buttons and show context menu
                if(container.hasClassName("sc_topic_button"))
                {
                    var menuChildren = $('contextMenuTopic').childNodes;
                    enableButtons(menuChildren);

                    $('contextMenuTopic').openPopup(container, "after_pointer", event.pageX-15, 0);
                }

                if(container.hasClassName("sc_crumb_button"))
                {
                    var menuChildren = $('contextMenuCrumb').childNodes;
                    enableButtons(menuChildren);
                    
                    $('contextMenuCrumb').openPopup(container, "after_pointer", event.pageX-15, 0);
                }   
                
                if(container.hasClassName("sc_page_button"))
                {
                    var menuChildren = $('contextMenuPage').childNodes;
                    enableButtons(menuChildren);
                    
                    $('contextMenuPage').openPopup(container, "after_pointer", event.pageX-15, 0);                                        
                }
                
                if(container.hasClassName("sc_people_button"))
                {
                    var menuChildren = $('contextMenuPeople').childNodes;
                    enableButtons(menuChildren);
                    
                    $('contextMenuPeople').openPopup(container, "after_pointer", event.pageX-15, 0);                                        
                }                
                
                
            }
            
            // Enable/disable buttons of edit/remove
            function enableButtons(menuItems)
            {
                for (var i = 0; i < menuItems.length; i++) 
                {
                    if(menuItems[i].id=="delete")
                    {
                        if(container.hasClassName('deleteable'))
                            menuItems[i].disabled = false;
                        else
                            menuItems[i].disabled = true;
                    }
                    if(menuItems[i].id=="edit")
                    {
                        if(container.hasClassName('editable'))
                            menuItems[i].disabled = false;
                        else
                            menuItems[i].disabled = true;
                    }                    
                    if(menuItems[i].id=="reconnectTopic")
                    {
                        // always false, this will be only available on the trash page
                        menuItems[i].disabled = true;                    

                    }
                    if(menuItems[i].id=="disconnectTopic")
                    {
                        if(container.hasClassName('multiple'))
                            menuItems[i].disabled = true;
                        else
                            menuItems[i].disabled = false;
                    }
                    if(menuItems[i].id=="standByTopic")
                    {
                        if(container.hasClassName('multiple'))
                            menuItems[i].disabled = true;
                        else
                            menuItems[i].disabled = false;
                    } 
                    if(menuItems[i].id=="addContact")
                    {
                        if(container.hasClassName('friend'))
                            menuItems[i].disabled = true;
                        else
                            menuItems[i].disabled = false;
                    }                                                             
                } 
            }
}


//*****************************
// Menu options / edit /
//*****************************

// for the edit functions need to include code on the page to call
// the function that draws the inputs for editing.
function contextMenuEditTopic(event)
{
    
    try
    {        
        var doc = $(getTabFrame(g_clickedFrame)).contentWindow.document;
        var script = doc.createElement("script");
        script.id = "SPREADCRUMBS_SCRIPTS";
        script.type = 'text/javascript';
        script.innerHTML = "editRightClickedContent();";
        doc.body.appendChild(script);        
    }
    catch(e)
    {
        alert(e);
    }
}


function contextMenuEditCrumb()
{
    try
    {        
        var doc = $("sc_sidebar_frame_trails").contentWindow.document;
        var script = doc.createElement("script");
        script.id = "SPREADCRUMBS_SCRIPTS";
        script.type = 'text/javascript';
        script.innerHTML = "editRightClickedContent();";
        doc.body.appendChild(script);        
    }
    catch(e)
    {
        alert(e);
    }
}

function contextMenuReplyCrumb()
{
    try
    {        
    
      gClickedObjectContainer.select('a').each(function(item){
        if( item.hasClassName("sc_trail_button_content_text") )  
        {  
          crumbUID = getIdFromComposedId(item.id, "crumb");
          topicUID = getIdFromComposedId(item.id, "topic");
        }
      }); 

      var popW = 1000;
      var popH = 650;
      var w = screen.availWidth;
      var h = screen.availHeight;
      var left = (w-popW)/2;
      var top = (h-popH)/2;   
      pop = window.openDialog(SERVER+"/spreadCrumbs_replyCrumbs_dlgff3.php?crumbId="+crumbUID+"&fromUserID="+g_sc_userUID, "Add Crumb", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
      pop.focus(); 
      
    }
    catch(e)
    {
        alert(e);
    }
}

function contextMenuAddContact()
{
    try
    {        
      var friendUID;
      gClickedObjectContainer.select('a').each(function(item){
        if( item.hasClassName("sc_trail_button_content_text") )  
        {  
            friendUID = item.id;
          
            if(friendUID)
            {
                var params= "sc_friendUID="+friendUID;
                var importAjaxURL= SERVER+"/ajax/spreadCrumbs_friends_add_ajax.php?"+params;

                  new Ajax.Request(importAjaxURL, {
                    onSuccess: function(transport) {
                      if(transport.responseText.indexOf('sc_ajax_success')>=0)
                      {
                          refreshFrame("sc_sidebar_frame_people");
                          return;
                      }
                    },
                     onFailure: function() {
                      alert("Couldn't add!");
                    }
                  });           
            }
        }
      }); 

    }
    catch(e)
    {
        alert(e);
    }
}

function finishReplyCrumbCheck()
{
    try
    {
        refreshFrame("sc_sidebar_frame_trails");
    }
    catch(e)
    {
        alert(e);
    }
}

function contextMenuEditPage()
{
    try
    {        
        var doc = $(getTabFrame(g_clickedFrame)).contentWindow.document;
        var script = doc.createElement("script");
        script.id = "SPREADCRUMBS_SCRIPTS";
        script.type = 'text/javascript';
        script.innerHTML = "editRightClickedContent();";
        doc.body.appendChild(script);        
    }
    catch(e)
    {
        alert(e);
    }
}

// for remove item just get the id, remove and refresh page
function contextMenuRemoveCrumb()
{
    try
    {      
          var crumbUID = null;
          var topicUID = null;
          gClickedObjectContainer.select('a').each(function(item){
            if( item.hasClassName("sc_trail_button_content_text") )  
            {  
              crumbUID = getIdFromComposedId(item.id, "crumb");
              topicUID = getIdFromComposedId(item.id, "topic");
            }
          });      

        var answer = scAskYesNoQuestion("Delete Crumb", "Deleting the last crumb will delete the topic. Are you sure you want to delete this crumb?", "Delete", "Cancel")
            
        if(answer)
        {
            params = "crumbUID=" +crumbUID; 
            params += "&topicUID=" + topicUID; 
            params += "&userUID=" +g_sc_userUID; 
            params += "&deleteSingleCrumb=true"; 

            var deleteAjaxURL= SERVER+"/ajax/spreadCrumbs_sidebar_delete_crumbs_ajax.php?"+params;

            new Ajax.Request(deleteAjaxURL, {
              onSuccess: function(transport) {
                if(transport.responseText.indexOf('sc_ajax_success')>=0)
                {
                    refreshFrame("sc_sidebar_frame_trails");
                    return;
                }
              },
               onFailure: function() {
                alert("Couldn't delete!");
              }
            });
            
            return;
        }    
    }
    catch(e)
    {
        alert(e);
    }
}
   
// for remove item just get the id, remove and refresh page    
// this works for pages also (when the visualization is not a group of topics in the page)
function contextMenuChangeTopicStatus(status, friendlyStatus)
{
    gClickedObjectContainer.select('a', 'b').each(function(item){
        if( item.hasClassName("sc_trail_button_content_text") )  
        {  
          topicUID = getIdFromComposedId(item.id, "topic");
        }
    }); 
      
    if( friendlyStatus=="" || !friendlyStatus)
        friendlyStatus = "change your status on this topic";
      
    var answer = scAskYesNoQuestion("Change Topic Status", 'Are you sure you want to "'+friendlyStatus+'"?', "Yes", "No");
   
    if(answer)
    {
        var params = "topicUID=" + topicUID; 
        params += "&status=" + status; 

        var changeStatusAjaxURL= SERVER+"/ajax/spreadCrumbs_sidebar_update_topic_status_ajax.php?"+params;

        new Ajax.Request(changeStatusAjaxURL, {
          onSuccess: function(transport) {
            if(transport.responseText.indexOf('sc_ajax_success')>=0)
            {
                if(g_clickedFrame=="Trail");
                {
                    refreshFrame("sc_sidebar_frame_trails");
                }
                
                if(status!="CONNECTED")
                    gClickedObjectContainer.style.display="none";
                return;
            }
          },
           onFailure: function() {
            alert("Couldn't change status!");
          }
        });
    }    
        
}

function refreshFrame(frameId, newPage)
{
    
    if(frameId=="sc_sidebar_frame_trails")
        $("filterTrail").value="";
    
    currentPage = $(frameId).getAttribute("src");
    
    if(newPage)
        currentPage = newPage;
    
    $(frameId).setAttribute("src", "");
    $(frameId).setAttribute("src", currentPage);
    
}

    $("sc_sidebar_frame_topics").addEventListener("DOMContentLoaded", function(e) { checkFrameAddress(e, "sc_sidebar_frame_topics"); }, false); 
    $("sc_sidebar_frame_pages").addEventListener("DOMContentLoaded", function(e) { checkFrameAddress(e, "sc_sidebar_frame_pages"); }, false); 
    $("sc_sidebar_frame_people").addEventListener("DOMContentLoaded", function(e) { checkFrameAddress(e, "sc_sidebar_frame_people"); }, false); 
    $("sc_sidebar_frame_trails").addEventListener("DOMContentLoaded", function(e) { checkFrameAddress(e, "sc_sidebar_frame_trails"); }, false); 

function checkFrameAddress(e, frameId)
{
    var blankPage = "chrome://spreadcrumbsdev/content/blank.html";
    var frame = $(frameId);
    
    if(frame.contentDocument.location.href!=blankPage)
    {
        // this element is hardCoded in each frame page as a hidden input.
        if(frame.contentDocument.getElementById("spreadcrumbs_sidebar_frame")==null)
        {
            frame.setAttribute("src", blankPage);
            
            //TODO: means connection problems!
        }
    } 
    //$("sc_sidebar_frame_topics").addEventListener("click", function(e) { onclickTabContent(e, "Topics"); }, false);    
}


//*****************************
// Filter values
//*****************************
function filterValues()
{
    
  try
  {

    if($("sc_sidebar_frame_topics").contentWindow)
        if($("sc_sidebar_frame_topics").contentWindow.document.getElementById("crumbTable"))
        {
            var topicsCrumbTable = $("sc_sidebar_frame_topics").contentWindow.document.getElementById("crumbTable");
            filterTable(topicsCrumbTable);
        }
    
    if($("sc_sidebar_frame_pages").contentWindow)
        if($("sc_sidebar_frame_pages").contentWindow.document.getElementById("crumbTable"))
        {
          var pagesCrumbTable = $("sc_sidebar_frame_pages").contentWindow.document.getElementById("crumbTable");
          filterTable(pagesCrumbTable);
        }
            
    if($("sc_sidebar_frame_people").contentWindow)
        if($("sc_sidebar_frame_people").contentWindow.document.getElementById("crumbTable"))
        {
          var peopleCrumbTable = $("sc_sidebar_frame_people").contentWindow.document.getElementById("crumbTable");
          filterTable(peopleCrumbTable);
        }

  }
  catch(e)
  {
    alert("fiterValues: " + e);
    
  }
}

function filterValuesTrail()
{
    
  try
  {
    if($("sc_sidebar_frame_trails").contentWindow)
        if($("sc_sidebar_frame_trails").contentWindow.document.getElementById("crumbTable"))
        {
          var trailCrumbTable = $("sc_sidebar_frame_trails").contentWindow.document.getElementById("crumbTable");
          filterTable(trailCrumbTable, 1);
        }

  }
  catch(e)
  {
    alert("fiterValues: " + e);
    
  }
}

//*****************************
// Filter values
//*****************************
function filterTable(crumbTable, trailView)
{
    try
    {
        var filterText = $('filter').value;
        
        if(trailView)
            filterText = $('filterTrail').value;

                    
        crumbTable.select('td').each(function(item){
            if(item.hasClassName("sc_trail_button_content"))
            {
                var content = item.innerText;
                if (!content)
                    content = item.textContent;
                if (!content)
                    content = "";
                var container = item.parentNode;
                
                var i = 0;
                while(container && (!container.hasClassName('sc_trail_button_container_row')) )
                {
                    container = container.parentNode;
                    i++;
                    if(i>20) //just to avoind infinite loop
                        break;
                }
                
                if (content.toLowerCase().indexOf(filterText.toLowerCase()) >= 0)
                {
                    //item.appear();
                    //item.parentNode.parentNode.appear();
                    //item.show();
                    //item.parentNode.parentNode.style.display="";            
                    container.show();
                }
                else
                {
                    //item.fade();
                    //item.parentNode.parentNode.fade();
                    //item.hide();
                    //item.parentNode.parentNode.style.display="none";
                    if(trailView)
                        container.hide();
                    else
                        item.parentNode.parentNode.parentNode.parentNode.parentNode.hide();
                }
            }
        });
    }
    catch(e)
    {
        alert(e);
    }
}

//*****************************
// Sorting Pages
//*****************************
g_sortingParam = "Date"; //Alpha
g_sortingOrient = "Reverse";

function sortButtonParam(how)
{
  try{
    /*
    var sourceId = "sortButton"+how;
    $("sortButtonParam").setAttribute("image",$(sourceId).image);
    $("sortButtonParam").setAttribute("label"," "+$(sourceId).label);
    $("sortButtonParamMenu").hidePopup();
    */
    
    if($("sortMenuButtonOrientationAsc").getAttribute("checked"))
        g_sortingOrient = "";
    else        
        g_sortingOrient = "Reverse";
        
    g_sortingParam = how;
    doSortOnCurrentFrame();
  }
  catch(e)
  {
    alert(e);
  }
}

function sortButtonOrient(orientation)
{
  try{   
    /*
    if( $("sortButtonOrient").image=="images/sc_up.gif" )
    {
      $("sortButtonOrient").setAttribute("image", "images/sc_down.gif");
      $("sortButtonOrient").setAttribute("label", " Ascending");
      g_sortingOrient = "";
    }
    else
    {
      $("sortButtonOrient").setAttribute("image", "images/sc_up.gif");
      $("sortButtonOrient").setAttribute("label", " Descending");
      g_sortingOrient = "Reverse";
    }
    */
        
    if(orientation)
        g_sortingOrient = "";
    else
        g_sortingOrient = "Reverse";
    
    doSortOnCurrentFrame();
  }
  catch(e)
  {
    alert(e);
  }      
}

function doSortOnCurrentFrame()
{
    try
    {
    
        var doc = $("sc_sidebar_frame_topics").contentWindow.document;
        var doc1 = $("sc_sidebar_frame_pages").contentWindow.document;
        var doc2 = $("sc_sidebar_frame_people").contentWindow.document;

        var script = doc.createElement("script");
        script.id = "SPREADCRUMBS_SCRIPTS";
        script.type = 'text/javascript';
        script.innerHTML = "sortContentAndDraw();";
        
        var script1 = doc.createElement("script");
        script1.id = "SPREADCRUMBS_SCRIPTS";
        script1.type = 'text/javascript';
        script1.innerHTML = "sortContentAndDraw();";
        
        var script2 = doc.createElement("script");
        script2.id = "SPREADCRUMBS_SCRIPTS";
        script2.type = 'text/javascript';
        script2.innerHTML = "sortContentAndDraw();";        
    
        doc.body.appendChild(script);
        doc1.body.appendChild(script1);
        doc2.body.appendChild(script2);
        
        filterValues();  
    }
    catch(e)
    {
        alert(e);
    }
}

//*****************************
// Get details of the trail
//*****************************
function selectItemOnTab(event, item, tab)
{
    try
    {
        if(item.hasClassName('sc_trail_button'))
        {
            var trailButton = item;

            //get the top element of the button to get the ID
            while(trailButton.parentNode && trailButton.parentNode.hasClassName('sc_trail_button'))
            {
                trailButton = trailButton.parentNode;
            }

            if(g_selectedButton)
                g_selectedButton.removeClassName('sc_trail_button_container_selected');
                
            trailButton.addClassName("sc_trail_button_container_selected");
            g_selectedButton = trailButton;

            var itemUID = trailButton.id;
            var param = "?tab="+tab+"&sc_userUID="+g_sc_userUID;
            
            if(tab=="People")
                param += "&friendUID="+itemUID;
            else
                param += "&topicUID="+itemUID;
            
            var url = SERVER+"/sidebar/spreadCrumbs_sidebar_trails_view.php"+param;
            refreshFrame("sc_sidebar_frame_trails", url);
            
            // if click on the "sc_link" opens the page
            if(item.hasClassName("sc_trail_link"))
            {
                g_mainWindow.gBrowser.selectedTab = g_mainWindow.getBrowser().addTab(event.target.id);

                var param = "?tab="+tab+"&sc_userUID="+g_sc_userUID+"&topicUID="+topicUID;
                $("sc_sidebar_frame_trails").setAttribute("src", SERVER+"/sidebar/spreadCrumbs_sidebar_trails_view.php"+param);    
            }
        }
    }
    catch(e)
    {
        
        // Do not show error
        // on begining item.hasClassName is not defined.
        //alert("selectItemOnTab: " + e);
    }
}


//*****************************
// returns only the crumb or topic id from the composed id.
//*****************************
function getIdFromComposedId(id, type)
{
    //if not composed
    if(id.indexOf("_")<0)
        return id;

    if(type=="crumb")
      return id.substring(id.indexOf("_")+1 , id.length);
    else if(type=="topic")
      return id.substring(0, id.indexOf("_"));      
}


function scAskYesNoQuestion(title, question, trueButton, falseButton)
{
    try
    {
        var scMessageTitle = title;
        var scMessageQuestion = question;
        var scMessageTrueButton = trueButton;
        var scMessageFalseButton = falseButton;
        window.scMessageTitle = scMessageTitle;
        window.scMessageQuestion = scMessageQuestion;
        window.scMessageTrueButton = scMessageTrueButton;
        window.scMessageFalseButton = scMessageFalseButton;
        window.returnValue = false;

        var wSize=300;
        if(scMessageQuestion.length>50)
            wSize=500;
        window.showModalDialog("chrome://spreadcrumbsDev/content/yesNoQuestionDlg.xul", 0, "dialogwidth: "+wSize+"px; dialogheight: 100px;")

        return window.returnValue;
    }
    catch(e)
    {
        return false;
    }
}


window.addEventListener("load", function(e) { onLoad(e); }, false); 
function onLoad()
{
    $("sc_sidebar_frame_topics").addEventListener("click", function(e) { onclickTabContent(e, "Topics"); }, false);    
    $("sc_sidebar_frame_pages").addEventListener("click", function(e) { onclickTabContent(e, "Pages"); }, false);    
    $("sc_sidebar_frame_people").addEventListener("click", function(e) { onclickTabContent(e, "People"); }, false);    
    $("sc_sidebar_frame_trails").addEventListener("click", function(e) { onclickViewContent(e, "Trail"); }, false);
}



g_lastCrumbFoundIndex = -1;
function findNextCrumbOnPage()
{
    try
    {
        mainWindow.findNextCrumbOnPage();
    }
    catch(e)
    {
        alert(e);
    }
}

function openUserInfoManager()
{
    if(!g_sc_userUID)
    {
        sc_logInOrOut();
        return;
                
    }
    
    var popW = 450;
    var popH = 430;
    var w = screen.availWidth;
    var h = screen.availHeight;
    var left = (w-popW)/2;
    var top = (h-popH)/2;    
      
    var infoWindow = window.openDialog(SERVER+"/sidebar/spreadCrumbs_sidebar_info.php", "User Information", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
    infoWindow.focus();
    return;      
}

function openFriendsManager()
{
    g_mainWindow.gBrowser.selectedTab = g_mainWindow.getBrowser().addTab(SERVER+"/spreadCrumbs_friends.php");    
}

function getTabFrame(tabName)
{
    if(tabName=='Topics')
    {
        return "sc_sidebar_frame_topics";
    }
  
    if(tabName=='Pages')
    {
        return "sc_sidebar_frame_pages";
    }
  
    if(tabName=='People')
    {
        return "sc_sidebar_frame_people";
    }  

    if(tabName=='Trail')
    {
        return "sc_sidebar_frame_trails";
    }             
    
    return false;
}
